unit uMiJoZisTicTacToe;

{ **************************************************************************** }
{ **************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ExtCtrls, StdCtrls, ShellApi, DateUtils,  Buttons, jpeg,
  uOptionen;

type
  { Spieler 1 ist immer "O", Spieler 2 immer "X" }
  TSpielstatus = (Sieger_O,Sieger_X,Unentschieden,Spiel_Laeuft);
  TSpielfeldmarkierung = (O,O_Sieg,X,X_Sieg,Freies_Feld);

  TFormHaupt = class(TForm)
    StsBarInfo: TStatusBar;
    MainMenNavi: TMainMenu;
    GrpBoxStatus: TGroupBox;
    LblSpieler1_1: TLabel;
    LblSpieler1_2: TLabel;
    LblSpieler2_1: TLabel;
    LblSpieler2_2: TLabel;
    LblSpielstaerke_1: TLabel;
    LblSpielstaerke_2: TLabel;
    LblZugNr_1: TLabel;
    LblZugNr_2: TLabel;
    LblAmZug_1: TLabel;
    LblAmZug_2: TLabel;
    Img_1_1: TImage;
    Img_1_2: TImage;
    Img_1_3: TImage;
    Img_2_1: TImage;
    Img_3_1: TImage;
    Img_3_2: TImage;
    Img_2_2: TImage;
    Img_3_3: TImage;
    Img_2_3: TImage;
    ShpGitter1: TShape;
    ShpGitter2: TShape;
    ShpGitter3: TShape;
    ShpGitter4: TShape;
    Spiel1: TMenuItem;
    Ueber: TMenuItem;
    Strich2: TMenuItem;
    Beenden: TMenuItem;
    TicTacToe: TMenuItem;
    Strich3: TMenuItem;
    Info: TMenuItem;
    TmrZeitgeber: TTimer;
    BvlTrenner: TBevel;
    PnlSpielfeld: TPanel;
    Strich1: TMenuItem;
    NeuesSpiel: TMenuItem;
    Optionen: TMenuItem;
    procedure BeendenClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure InfoClick(Sender: TObject);
    procedure TicTacToeClick(Sender: TObject);
    procedure TmrZeitgeberTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Img_1_1Click(Sender: TObject);
    procedure Img_1_2Click(Sender: TObject);
    procedure Img_1_3Click(Sender: TObject);
    procedure Img_2_1Click(Sender: TObject);
    procedure Img_2_2Click(Sender: TObject);
    procedure Img_2_3Click(Sender: TObject);
    procedure Img_3_1Click(Sender: TObject);
    procedure Img_3_2Click(Sender: TObject);
    procedure Img_3_3Click(Sender: TObject);
    procedure NeuesSpielClick(Sender: TObject);
    procedure OptionenClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure Computerzug;
    procedure Zugabschliessen;
    procedure SpielfeldAusgeben;
    function Spielstatus: TSpielstatus;
  public
    { Public-Deklarationen }
  end;

const
  VERSION = '0.9';

var
  FormHaupt: TFormHaupt;
  Spielfeld: array[1..3,1..3] of TSpielfeldmarkierung;
  AmZug: TSpielfeldmarkierung;
  ZugNr: Byte;

{ **************************************************************************** }
{ **************************************************************************** }

implementation

{$R *.dfm}

{ ***  EIGENE PROZEDUREN/FUNKTIONEN  ***************************************** }

procedure Delay(Millisekunden: Integer);
var
  Tick: DWord;
  Event: THandle;
begin
  Event := CreateEvent(nil,False,False,nil);
  try
    Tick := GetTickCount + DWord(Millisekunden);
    while (Millisekunden > 0) and
      (MsgWaitForMultipleObjects(1,Event,False,Millisekunden,QS_ALLINPUT) <> WAIT_TIMEOUT) do begin
      Application.ProcessMessages;  { Sichert, dass das Programm noch Ereignisse verarbeitet und nicht "einfriert";
                                      Ereignisse (Botschaften) in Applikations-Warteschlange werden hier abgearbeitet }
      if Application.Terminated then Exit;
      Millisekunden := Tick - GetTickcount;
    end;
  finally
    CloseHandle(Event);
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Computerzug;
var
  ZufallX,ZufallY: Integer;
begin
  { Spielfeld fuer Eingaben sperren (damit User nicht waehrend Computerzug klickt) }
  PnlSpielfeld.Enabled := False;

  { Falls Spielstaerke = stupid... }
  if FormOptionen.RadGrpSpielstaerke.ItemIndex = 0 then begin
    { Computerzug ist ein Zufallszug (so lange Koordinaten erzeugen, bis ein freies Feld gefunden) }
    repeat
      ZufallX := Random(3) + 1;
      ZufallY := Random(3) + 1;
    until Spielfeld[ZufallX,ZufallY] = Freies_Feld;
    Spielfeld[ZufallX,ZufallY] := AmZug;
  end
  { Falls Spielstaerke = god... }
  else if FormOptionen.RadGrpSpielstaerke.ItemIndex = 1 then begin
    { NOCH NICHT IMPLEMENTIERT!!! }
  end;

  { Verzoegerung (1 Sekunde) }
  Delay(1000);

  { Spielfeld entsperren }
  PnlSpielfeld.Enabled := True;

  { Zug beenden }
  Zugabschliessen;
end;

{ **************************************************************************** }

procedure TFormHaupt.ZugAbschliessen;
var
  Spielstatus_Rueckgabe: TSpielstatus;  { Damit in Code unten Funktion "Spielstatus" nicht mehrfach aufgerufen werden muss }
begin
  { Spielstatus ueberpruefen }
  Spielstatus_Rueckgabe := Spielstatus;

  { Wenn das Spiel noch laeuft... }
  if Spielstatus_Rueckgabe = Spiel_Laeuft then begin
    { Ausgabe Spielfeld }
    SpielfeldAusgeben;

    { Zugnummer hochzaehlen }
    Inc(ZugNr);
    LblZugNr_2.Caption := IntToStr(ZugNr);

    { Naechster Spieler am Zug aendern }
    if AmZug = O then begin  { Spieler 1 war am Zug }
      AmZug := X;  { Spieler 2 ist als naechstes am Zug }
      LblAmZug_2.Caption := LblSpieler2_2.Caption;
    end
    else begin  { Spieler 2 war am Zug }
      AmZug := O;  { Spieler 1 ist als naechstes am Zug }
      LblAmZug_2.Caption := LblSpieler1_2.Caption;
    end;

    { Ggf.Computerzug }
    if ((FormOptionen.RadGrpSpielart.ItemIndex = 1) and (ZugNr mod 2 = 0)) or
      ((FormOptionen.RadGrpSpielart.ItemIndex = 2) and (ZugNr mod 2 = 1)) then Computerzug;
  end

  { Wenn das Spiel beendet ist... }
  else begin
    { Ausgabe Spielfeld }
    SpielfeldAusgeben;

    { Mitteilung ueber Spielausgang }
    case Spielstatus_Rueckgabe of
      Sieger_O:      MessageDlg('Spieler 1 hat gewonnen!',mtInformation,[mbOK],0);
      Sieger_X:      MessageDlg('Spieler 2 hat gewonnen!',mtInformation,[mbOK],0);
      Unentschieden: MessageDlg('Unentschieden - kein Spieler hat gewonnen!',mtInformation,[mbOK],0);
    end;

    { Spielfeld fuer Eingaben sperren }
    PnlSpielfeld.Enabled := False;
    { Menueeintraege }
    NeuesSpiel.Enabled := True;
    Optionen.Enabled := True;
    { Sielfeld-Hint aktivieren }
    PnlSpielfeld.ShowHint := True;
    { Statusbar-Ausgabe }
    StsBarInfo.Panels.Items[0].Text := 'Whlen Sie "Spiel --> Neues Spiel", um zu beginnen.';
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.SpielfeldAusgeben;
{ Ausgehend von interner Datenstruktur des Spielfeldes 2D-Array "Spielfeld" nun die Grafiken ins Formular laden }
var
  i,j,k: Integer;
  Pfad: string;
begin
  { Array "durchgehen" }
  for i := 1 to 3 do
    for j := 1 to 3 do begin
      { Grafik auswaehlen }
      case Spielfeld[i,j] of
        O:           Pfad := ExtractFilePath(Application.ExeName) + 'Bilder/O.jpg';
        O_Sieg:      Pfad := ExtractFilePath(Application.ExeName) + 'Bilder/O_Sieg.jpg';
        X:           Pfad := ExtractFilePath(Application.ExeName) + 'Bilder/X.jpg';
        X_Sieg:      Pfad := ExtractFilePath(Application.ExeName) + 'Bilder/X_Sieg.jpg';
        Freies_Feld: Pfad := ExtractFilePath(Application.ExeName) + 'Bilder/Freies_Feld.jpg';
      end;
      { Grafik ausgeben (inkl. Error-Handling) }
      if FileExists(Pfad) then begin  { begin-end-Klammerung hier wg. nicht zu haeufiger Fehlermeldungsausgabe sinnvoll }
        for k := 0 to PnlSpielfeld.ControlCount - 1 do
          if (PnlSpielfeld.Controls[k] is TImage) and
            (TImage(PnlSpielfeld.Controls[k]).Name = 'Img_' + IntToStr(i) + '_' + IntToStr(j)) then
              TImage(PnlSpielfeld.Controls[k]).Picture.LoadFromFile(Pfad);
      end
      else
        { Fehlermeldung anzeigen }
        MessageDlg('Die Bilddatei' + #13 + #13 + '"' + Pfad + '"' + #13 + #13 +
          'konnte nicht gefunden werden!',mtError,[mbOK],0);
    end;
end;

{ **************************************************************************** }

function TFormHaupt.Spielstatus: TSpielstatus;
{ Anm.: Leider etwas umstaendlich wirkend - wuesste jedoch nicht, wie man codeeffizienter schreiben koennte }
var
  i,j: Integer;
  AlleFelderBelegt: Boolean;
begin
  { Initialisierung (davon ausgehen, dass Spielende nicht erreicht) }
  Result := Spiel_Laeuft;

  { Fall 1: Spieler 1 gewonnen? }

  { Waagerecht (oben, Mitte, unten) }
  for i := 1 to 3 do
    if (Spielfeld[i,1] = O) and (Spielfeld[i,2] = O) and (Spielfeld[i,3] = O) then begin
      Result := Sieger_O;
      { "Siegermarkierung" setzen fuer grafische Ausgabe }
      Spielfeld[i,1] := O_Sieg;  Spielfeld[i,2] := O_Sieg;  Spielfeld[i,3] := O_Sieg;
      Exit;  { Prozedur verlassen }
    end;

  { Senkrecht (links, Mitte, rechts) }
  for i := 1 to 3 do
    if (Spielfeld[1,i] = O) and (Spielfeld[2,i] = O) and (Spielfeld[3,i] = O) then begin
      Result := Sieger_O;
      { "Siegermarkierung" setzen fuer grafische Ausgabe }
      Spielfeld[1,i] := O_Sieg;  Spielfeld[2,i] := O_Sieg;  Spielfeld[3,i] := O_Sieg;
      Exit;  { Prozedur verlassen }
    end;

  { Diagonal I (oben links - unten rechts) }
  if (Spielfeld[1,1] = O) and (Spielfeld[2,2] = O) and (Spielfeld[3,3] = O) then begin
    Result := Sieger_O;
    { "Siegermarkierung" setzen fuer grafische Ausgabe }
    Spielfeld[1,1] := O_Sieg;  Spielfeld[2,2] := O_Sieg;  Spielfeld[3,3] := O_Sieg;
    Exit;  { Prozedur verlassen }
  end;

  { Diagonal II (unten links - oben rechts) }
  if (Spielfeld[3,1] = O) and (Spielfeld[2,2] = O) and (Spielfeld[1,3] = O) then begin
    Result := Sieger_O;
    { "Siegermarkierung" setzen fuer grafische Ausgabe }
    Spielfeld[3,1] := O_Sieg;  Spielfeld[2,2] := O_Sieg;  Spielfeld[1,3] := O_Sieg;
    Exit;  { Prozedur verlassen }
  end;

  { Fall 2: Spieler 2 gewonnen? }

  { Waagerecht (oben, Mitte, unten) }
  for i := 1 to 3 do
    if (Spielfeld[i,1] = X) and (Spielfeld[i,2] = X) and (Spielfeld[i,3] = X) then begin
      Result := Sieger_X;
      { "Siegermarkierung" setzen fuer grafische Ausgabe }
      Spielfeld[i,1] := X_Sieg;  Spielfeld[i,2] := X_Sieg;  Spielfeld[i,3] := X_Sieg;
      Exit;  { Prozedur verlassen }
    end;

  { Senkrecht (links, Mitte, rechts) }
  for i := 1 to 3 do
    if (Spielfeld[1,i] = X) and (Spielfeld[2,i] = X) and (Spielfeld[3,i] = X) then begin
      Result := Sieger_X;
      { "Siegermarkierung" setzen fuer grafische Ausgabe }
      Spielfeld[1,i] := X_Sieg;  Spielfeld[2,i] := X_Sieg;  Spielfeld[3,i] := X_Sieg;
      Exit;  { Prozedur verlassen }
    end;

  { Diagonal I (oben links - unten rechts) }
  if (Spielfeld[1,1] = X) and (Spielfeld[2,2] = X) and (Spielfeld[3,3] = X) then begin
    Result := Sieger_X;
    { "Siegermarkierung" setzen fuer grafische Ausgabe }
    Spielfeld[1,1] := X_Sieg;  Spielfeld[2,2] := X_Sieg;  Spielfeld[3,3] := X_Sieg;
    Exit;  { Prozedur verlassen }
  end;

  { Diagonal II (unten links - oben rechts) }
  if (Spielfeld[3,1] = X) and (Spielfeld[2,2] = X) and (Spielfeld[1,3] = X) then begin
    Result := Sieger_X;
    { "Siegermarkierung" setzen fuer grafische Ausgabe }
    Spielfeld[3,1] := X_Sieg;  Spielfeld[2,2] := X_Sieg;  Spielfeld[1,3] := X_Sieg;
    Exit;  { Prozedur verlassen }
  end;

  { Fall 3: Unentschieden (--> wenn alle Felder belegt und kein Sieger)? }

  AlleFelderBelegt := True;  { Davon ausgehen, dass alle Felder belegt sind }
  for i := 1 to 3 do
    for j := 1 to 3 do
      if Spielfeld[i,j] = Freies_Feld then AlleFelderBelegt := False;  { Sobald ein Feld leer ist, kein Unentschieden }
  if AlleFelderBelegt then Result := Unentschieden;
end;

{ ***  PROGRAMMSTART  ******************************************************** }

procedure TFormHaupt.FormActivate(Sender: TObject);
begin
  { Zufallsgenerator aktivieren }
  Randomize;

  { Formularbeschriftung }
  FormHaupt.Caption := 'MiJoZis Tic Tac Toe (V' + VERSION + ')';

  { Willkommensdialog anzeigen }
  MessageDlg('Willkommen zu MiJoZis Tic Tac Toe (V' + VERSION + ')!' + #13 + #13 +
    'Um ein neues Spiel zu beginnen, passen Sie bitte ggf. die Spieloptionen an und whlen Sie' + #13 +
    '"Spiel --> Neues Spiel".' + #13 + #13 + 'Viel Spa und Erfolg!',mtInformation,[mbOK],0);
end;

{ **************************************************************************** }

procedure TFormHaupt.FormCreate(Sender: TObject);
var
  i,j: Integer;
begin
  { (Re-)Initialisierungen }

  { Variablen }
  AmZug := O;
  ZugNr := 1;

  { Spielfeld-Array "leeren" }
  for i := 1 to 3 do
    for j := 1 to 3 do
      Spielfeld[i,j] := Freies_Feld;

  { Ausgabe Spielfeld }
  SpielfeldAusgeben;

  { Statusinformationen ausgeben (restliche Informationen werden nur bei Klick auf Optionen geaendert) }
  LblZugNr_2.Caption := IntToStr(ZugNr);
  LblAmZug_2.Caption := LblSpieler1_2.Caption;

  { Statusbar-Ausgabe }
  StsBarInfo.Panels.Items[0].Text := 'Whlen Sie "Spiel --> Neues Spiel", um zu beginnen.';
end;

{ **************************************************************************** }

procedure TFormHaupt.TmrZeitgeberTimer(Sender: TObject);
var
  Wochentag: string;
begin
  { Wochentag berechnen }
  case DayOfTheWeek(Now) of  { DayOfThe Week ist vorhanden in Unit DateUtils }
    1: Wochentag := 'Mo.';
    2: Wochentag := 'Di.';
    3: Wochentag := 'Mi.';
    4: Wochentag := 'Do.';
    5: Wochentag := 'Fr.';
    6: Wochentag := 'Sa.';
    7: Wochentag := 'So.';
  end;

  { Datum ausgeben }
  StsBarInfo.Panels.Items[1].Text := Wochentag + ', ' + DateToStr(Date) + ' | ' + TimeToStr(Time) + ' Uhr';
end;

{ ***  MENUEEINTRAEGE  ******************************************************* }

procedure TFormHaupt.NeuesSpielClick(Sender: TObject);
begin
  { (Re-)Initialisierung }
  FormCreate(Self);

  { Spielfeld-Gitter sichtbar schalten (im Grunde nur fuer den ersten Aufruf dieser Prozedur benoetigt, da sonst nirgends deaktiviert) }
  ShpGitter1.Visible := True;
  ShpGitter2.Visible := True;
  ShpGitter3.Visible := True;
  ShpGitter4.Visible := True;
  
  { Spielfeld fuer Eingaben freigeben ("entsperren") }
  PnlSpielfeld.Enabled := True;

  { Menueeintraege }
  NeuesSpiel.Enabled := False;
  Optionen.Enabled := False;

  { Sielfeld-Hint deaktivieren }
  PnlSpielfeld.ShowHint := False;

  { Statusbar-Ausgabe }
  StsBarInfo.Panels.Items[0].Text := 'Partie luft!';

  { Ggf. Computerzug (falls Partie Maschine - Mensch, da Computer hier zuerst zieht) }
  if FormOptionen.RadGrpSpielart.ItemIndex = 2 then Computerzug;
end;

{ **************************************************************************** }

procedure TFormHaupt.OptionenClick(Sender: TObject);
begin
  { Optionsformular aufrufen }
  FormOptionen.ShowModal;

  { Optionen einlesen }
  case FormOptionen.RadGrpSpielart.ItemIndex of
    0: begin
         LblSpieler1_2.Caption := 'Mensch (O)';
         LblSpieler2_2.Caption := 'Mensch (X)';
         LblSpielstaerke_2.Caption := '-';
         LblAmZug_2.Caption := 'Mensch (O)';
       end;
    1: begin
         LblSpieler1_2.Caption := 'Mensch (O)';
         LblSpieler2_2.Caption := 'Maschine (X)';
         if FormOptionen.RadGrpSpielstaerke.ItemIndex = 0 then LblSpielstaerke_2.Caption := 'stupid'
           else LblSpielstaerke_2.Caption := 'god';
         LblAmZug_2.Caption := 'Mensch (O)';
       end;
    2: begin
         LblSpieler1_2.Caption := 'Maschine (O)';
         LblSpieler2_2.Caption := 'Mensch (X)';
         LblSpielstaerke_2.Caption := '-';
         if FormOptionen.RadGrpSpielstaerke.ItemIndex = 0 then LblSpielstaerke_2.Caption := 'stupid'
           else LblSpielstaerke_2.Caption := 'god';
         LblAmZug_2.Caption := 'Maschine (O)';
       end;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.BeendenClick(Sender: TObject);
begin
  { Beachte auch "procedure TForm1.FormCloseQuery" }
  Close;
end;

{ **************************************************************************** }

procedure TFormHaupt.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  { Initialisierung }
  CanClose := False;
  
  { Sicherheitsabfrage }
  if MessageDlg('Mchten Sie "MiJoZis Tic Tac Toe" wirklich beenden?',mtConfirmation,
    [mbYes,mbNo],0) = mrYes then CanClose := True;
end;

{ **************************************************************************** }

procedure TFormHaupt.TicTacToeClick(Sender: TObject);
begin
  { Wikipedia-Site zu "Tic Tac Toe" aufrufen }
  ShellExecute(Application.Handle, 'open', 'http://de.wikipedia.org/wiki/Tic_Tac_Toe', nil, nil, SW_SHOWNORMAL);
end;

{ **************************************************************************** }

procedure TFormHaupt.InfoClick(Sender: TObject);
begin
  MessageDlg('MiJoZis Tic Tac Toe (V' + VERSION + ')' + #13 + #13 +
    'M. Zirbes, 2009' + #13 + #13 +
    'Bei diesem Programm handelt es sich um Freeware,' + #13 +
    'd.h. es steht zur kostenlosen Nutzung frei zur Verfgung' + #13 +
    'und darf ohne Entgelt vervielfltigt und verbreitet werden.' + #13 + #13 +
    'Kontakt: schule@mijozi.de',mtInformation,[mbOK],0);
end;

{ ***  FORMULARKOMPONENTEN  ************************************************** }

procedure TFormHaupt.Img_1_1Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[1,1] = Freies_Feld then begin
    Spielfeld[1,1] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_1_2Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[1,2] = Freies_Feld then begin
    Spielfeld[1,2] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_1_3Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[1,3] = Freies_Feld then begin
    Spielfeld[1,3] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_2_1Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[2,1] = Freies_Feld then begin
    Spielfeld[2,1] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_2_2Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[2,2] = Freies_Feld then begin
    Spielfeld[2,2] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_2_3Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[2,3] = Freies_Feld then begin
    Spielfeld[2,3] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_3_1Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[3,1] = Freies_Feld then begin
    Spielfeld[3,1] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_3_2Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[3,2] = Freies_Feld then begin
    Spielfeld[3,2] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }

procedure TFormHaupt.Img_3_3Click(Sender: TObject);
begin
  { Nur bei freiem Feld Markierung setzen }
  if Spielfeld[3,3] = Freies_Feld then begin
    Spielfeld[3,3] := AmZug;
    ZugAbschliessen;
  end;
end;

{ **************************************************************************** }
{ **************************************************************************** }

end.
